=== debian/changelog ===
jpegqs (1.20210408-3) unstable; urgency=medium

  * Fix a divide by zero on corrupted images (closes: #1017608,
    CVE-2022-35434).

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 18 Aug 2022 14:23:00 +0200

jpegqs (1.20210408-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Let dh_auto_build pass cross tools to make. (Closes: #992507)

  [ Adam Borowski ]
  * Add Thomas G. Lane to d/copyright.

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 22 Aug 2021 03:55:40 +0200

jpegqs (1.20210408-1) unstable; urgency=medium

  * Initial release (Closes: #989697)

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 30 Jun 2021 17:59:52 +0200
