=== debian/control ===
Source: jpegqs
Section: graphics
Priority: optional
Maintainer: Adam Borowski <kilobyte@angband.pl>
Build-Depends: debhelper-compat (= 13), libjpeg-dev
Standards-Version: 4.5.1
Homepage: https://github.com/ilyakurdyukov/jpeg-quantsmooth/
Vcs-Browser: https://github.com/kilobyte/jpegqs
Vcs-Git: https://github.com/kilobyte/jpegqs
Rules-Requires-Root: no

Package: jpegqs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: JPEG artifacts removal tool
 JPEG Quant Smooth tries to recover the lost precision of DCT
 coefficients based on a quantization table from a JPEG image.
