=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all


%:
	dh $@

build-arch:
	if dpkg-architecture --is any-amd64; then \
		dh_auto_build -- SIMD=select $(shell dpkg-buildflags --export=cmdline); \
	else \
		dh_auto_build -- SIMD=none $(shell dpkg-buildflags --export=cmdline); \
	fi
