=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%jpegqs-$1.tar.gz%" \
   https://github.com/ilyakurdyukov/jpeg-quantsmooth/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
